/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

#define RSCMW_NAN                 9.91e+37
#define RSCMW_NAN_VI_INT32        0x80000000

ViStatus rscmwevm_InitAttributes (ViSession vi);
ViStatus rscmwevm_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rscmwevm_CheckStatus (ViSession vi);
ViStatus rscmwevm_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 rscmwevm_StringIndex(ViString array[], ViChar buff[]); 
ViStatus rscmwevm_invalidViInt32Range (ViSession instrSession, ViInt32 val, ViInt32 min, ViInt32 max);
ViStatus rscmwevm_invalidViUInt16Range (ViSession instrSession, ViUInt16 val, ViUInt16 min, ViUInt16 max);
ViStatus rscmwevm_invalidViReal64Range (ViSession instrSession, ViReal64 val, ViReal64 min, ViReal64 max);
ViStatus rscmwevm_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
ViStatus rscmwevm_instanceRepCap (ViSession instrSession, ViInt32 instance, ViChar rep_cap[]);
ViStatus rscmwevm_instance_mevMeasRepCap (ViSession instrSession, ViInt32 instance, ViInt32 measurement, ViChar rep_cap[]);
ViStatus _VI_FUNC rscmwevm_QueryMeasStatus(
    ViSession   instrSession,
    ViString    command,
    ViInt32*    mainState,
    ViInt32*    syncState,
    ViInt32*    resourcesState);
ViStatus _VI_FUNC rscmwevm_GetMeas(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32*    reliability,
    ViReal64    result[]);
ViStatus _VI_FUNC rscmwevm_GetMeasList(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     *segmentReliability,
    ViReal64     results[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasListState(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     *segmentReliability,
    ViInt32     results[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasListAll(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     ActiveSegmentsCount,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     segmentReliability[],
    ViReal64    results[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_QueryMeasListAll(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     ActiveSegmentsCount,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     segmentReliability[],
    ViInt32     results[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasListStateAll(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     ActiveSegmentsCount,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     segmentReliability[],
    ViInt32     results[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasTraceLimitsAll(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     *segmentReliability,
    ViInt32     result[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasTrace(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViReal64    result[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetMeasTraceLimits(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     result[],
    ViInt32     *returnedValues);
ViStatus _VI_FUNC rscmwevm_GetCatalog(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViChar      catalog[]
    );
ViStatus _VI_FUNC rscmwevm_GetMeasTraceStates(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     result[],
    ViInt32     *returnedValues
    );
ViStatus _VI_FUNC rscmwevm_GetMeasReliabilitiesAll(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     ActiveSegmentsCount,
    ViInt32*    reliability,
    ViInt32     segmentReliability[],
    ViInt32     *returnedValues
    );
 ViStatus _VI_FUNC rscmwevm_GetMeasTraceState(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViInt32     result[],
    ViInt32     *returnedValues
    );
ViReal64 rscmwevm_atof (ViChar *p2buf);
ViInt32 rscmwevm_strCode(ViChar *pBuffer, ViString arrayCodes[]);
ViInt32 rscmwevm_atol (ViChar *p2buf);
