/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

#define RSCMW_NAN                 9.91e+37
#define RSCMW_NAN_VI_INT32        0x80000000

ViStatus rscmwevs_InitAttributes (ViSession vi);
ViStatus rscmwevs_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rscmwevs_CheckStatus (ViSession vi);
ViStatus rscmwevs_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 rscmwevs_StringIndex(ViString array[], ViChar buff[]); 
ViStatus rscmwevs_invalidViInt32Range (ViSession instrSession, ViInt32 val, ViInt32 min, ViInt32 max);
ViStatus rscmwevs_invalidViReal64Range (ViSession instrSession, ViReal64 val, ViReal64 min, ViReal64 max);
ViStatus rscmwevs_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
ViStatus rscmwevs_instanceRepCap (ViSession instrSession, ViInt32 instance, ViChar rep_cap[]);
ViStatus _VI_FUNC rscmwevs_GetMeasString(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViChar      result[],
    ViInt32*    returnedValues
    );
ViStatus _VI_FUNC rscmwevs_GetMeasReal(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViReal64*    result);
ViStatus _VI_FUNC rscmwevs_GetMeasInt(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32*    result);
ViReal64 rscmwevs_atof (ViChar *p2buf);
ViInt32 rscmwevs_atol (ViChar *p2buf);
ViStatus _VI_FUNC rscmwevs_QueryMeasStatus(
    ViSession   instrSession,
    ViString    command,
    ViInt32*    mainState,
    ViInt32*    syncState,
    ViInt32*    resourcesState
    );
ViStatus _VI_FUNC rscmwevs_GetMeasResults(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32*    reliability,
    ViReal64    result[],
    ViInt32     *returnedValues
    );
ViStatus _VI_FUNC rscmwevs_GetLimitCheckResults(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32     *reliability,
    ViInt32     codes[],
    ViInt32     *returnedValues
    );
ViStatus _VI_FUNC rscmwevs_GetPerformanceResults(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32 *packetSize,
    ViInt32     *reliability,
    ViReal64    result[],
    ViInt32     *returnedValues
    );
ViStatus rscmwevs_GetLimitCheckPerformanceResults(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViInt32     *reliability,
    ViInt32     *packetSize,
    ViInt32     codes[],
    ViInt32     *returnedValues
    );
ViStatus _VI_FUNC rscmwevs_GetCarrierStatus(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     *reliability,
    ViInt32     *status
    );
ViStatus _VI_FUNC rscmwevs_GetCatalog(
    ViSession   instrSession,
    ViString    command,
    ViInt32     timeout,
    ViInt32     arraySize,
    ViChar      catalog[]
    );
